package com.casic.missiles.service.meter;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.casic.missiles.dto.BaseApprovalSubmitRequest;
import com.casic.missiles.dto.ReturnDTO;
import com.casic.missiles.dto.flowable.ApprovalDeleteRequest;
import com.casic.missiles.dto.meter.*;
import com.casic.missiles.model.meter.MeterFile;

import java.util.List;

/**
 * <p>
 * 计量管理-计量文件-文件表 服务类
 * </p>
 *
 * @author wangpeng
 * @since 2022-11-22
 */
public interface IMeterFileService extends IService<MeterFile> {

    Page<MeterFile> listPage(Page<MeterFile> page, FileListRequest request);

    List<MeterFile> list(FileListRequest request);

    ReturnDTO<FileSaveResponse> saveFile(MeterFile meterFile);

    ReturnDTO submitFile(BaseApprovalSubmitRequest request);

    ReturnDTO draftUpdate(MeterFile meterFile);

    ReturnDTO updateFile(Long id);

    ReturnDTO deleteFile(Long id);

    ReturnDTO deleteBatchFile(List<Long> ids);

    List<FileApprovalListResponse> approvalListPage(Page<FileApprovalListResponse> page, FileApprovalListRequest request);

    ReturnDTO approvalDelete(ApprovalDeleteRequest request);

    ReturnDTO failUpdate(MeterFile meterFile);

    ReturnDTO querySelectList();

    List<MeterFile> list(List<Long> ids);
}
